Index: wsdl/abac.wsdl
===================================================================
--- wsdl/abac.wsdl	(revision 132440f265f8547bbedb673632c193befdb1142f)
+++ wsdl/abac.wsdl	(revision 1c599259ed103bb5a427a6f1c4000998e07ad7f7)
@@ -49,4 +49,12 @@
   </message>
 
+  <message name="AddCredentialRequestMessage">
+    <part name="AddCredentialRequestBody" type="xsd1:addCredentialRequest"/>
+  </message>
+
+  <message name="AddCredentialResponseMessage">
+    <part name="AddCertificateResponseBody" type="xsd1:addCredentialResponse"/>
+  </message>
+
   <message name="AddCertificateRequestMessage">
     <part name="AddCertificateRequestBody" type="xsd1:addCertificateRequest"/>
@@ -66,4 +74,12 @@
   </message>
 
+  <message name="TrustRequestMessage">
+    <part name="AccessRequestBody" type="xsd1:trustRequest"/>
+  </message>
+
+  <message name="TrustResponseMessage">
+    <part name="AccessResponseBody" type="xsd1:trustResult"/>
+  </message>
+
   <message name="AccessRequestMessage">
     <part name="AccessRequestBody" type="xsd1:negotiationRequest"/>
@@ -107,4 +123,12 @@
       <fault name="NegotiateFeddFault" message="tns:FaultMessage"/>
     </operation>
+    <operation name="Trust">
+      <documentation>
+	Request access to a resource on behalf of a principal
+      </documentation>
+      <input message="tns:TrustRequestMessage"/>
+      <output message="tns:TrustResponseMessage"/>
+      <fault name="NegotiateFeddFault" message="tns:FaultMessage"/>
+    </operation>
     <operation name="CredentialUpdate">
       <documentation>
@@ -129,4 +153,12 @@
       <input message="tns:AddCertificateRequestMessage"/>
       <output message="tns:AddCertificateResponseMessage"/>
+      <fault name="NegotiateFeddFault" message="tns:FaultMessage"/>
+    </operation>
+    <operation name="AddCredential">
+      <documentation>
+	Publishes a new X.509 identity certificate globally
+      </documentation>
+      <input message="tns:AddCredentialRequestMessage"/>
+      <output message="tns:AddCredentialResponseMessage"/>
       <fault name="NegotiateFeddFault" message="tns:FaultMessage"/>
     </operation>
@@ -197,4 +229,17 @@
 	    encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"/>
 	</output>
+      </operation>
+      <operation name="Trust">
+	<soap:operation soapAction="TrustRequest"/> 
+	<input>
+	  <soap:body use="literal" parts="tns:TrustRequestBody"
+	    namespace="http://www.isi.edu/fedd.wsdl"
+	    encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"/>
+	</input>
+	<output>
+	  <soap:body use="literal" parts="tns:TrustResponseBody"
+	    namespace="http://www.isi.edu/fedd.wsdl"
+	    encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"/>
+	</output>
 	<fault name="NegotiateFeddFault">
 	  <soap:fault use="literal"  name="tns:FeddFault"
@@ -230,4 +275,22 @@
         <output>
           <soap:body use="literal" parts="tns:AddCertificateResponseBody"
+            namespace="http://www.isi.edu/fedd.wsdl"
+            encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"/>
+        </output>
+        <fault name="NegotiateFeddFault">
+          <soap:fault use="literal"  name="tns:FeddFault"
+            namespace="http://www.isi.edu/fedd.wsdl"
+            encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"/>
+        </fault>
+      </operation>
+      <operation name="AddCredential">
+        <soap:operation soapAction="AddCredential"/>
+        <input>
+          <soap:body use="literal" parts="tns:AddCredentialRequestBody"
+            namespace="http://www.isi.edu/fedd.wsdl"
+            encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"/>
+        </input>
+        <output>
+          <soap:body use="literal" parts="tns:AddCredentialResponseBody"
             namespace="http://www.isi.edu/fedd.wsdl"
             encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"/>
Index: wsdl/abac_types.xsd
===================================================================
--- wsdl/abac_types.xsd	(revision 132440f265f8547bbedb673632c193befdb1142f)
+++ wsdl/abac_types.xsd	(revision 1c599259ed103bb5a427a6f1c4000998e07ad7f7)
@@ -51,4 +51,38 @@
       <xsd:element name="provenance" type="xsd:string"
 	minOccurs="0" maxOccurs="1"/>
+    </xsd:sequence>
+  </xsd:complexType>
+
+  <xsd:complexType name="trustRequest">
+    <xsd:sequence>
+      <xsd:element name="context" type="tns:contextInfo"/>
+      <xsd:element name="peerURL" type="xsd:string"/>
+      <xsd:element name="peerContext" type="tns:contextInfo"/>
+      <xsd:element name="selfURL" type="xsd:string"/>
+      <xsd:element name="goal" type="tns:flatGoalType"/>
+    </xsd:sequence>
+  </xsd:complexType>
+
+  <xsd:complexType name="trustResult">
+    <xsd:sequence>
+      <xsd:element name="goal" type="tns:flatGoalType"/>
+      <xsd:element name="result" type="xsd:string"/>
+      <xsd:element name="provenance" type="xsd:string"
+	minOccurs="0" maxOccurs="1"/>
+    </xsd:sequence>
+  </xsd:complexType>
+
+  <xsd:complexType name="addCredentialRequest">
+    <xsd:sequence>
+      <xsd:element name="type" type="xsd:string"/>
+      <xsd:element name="cred" type="xsd:string"/>
+      <xsd:element name="context" type="tns:contextInfo"/>
+    </xsd:sequence>
+  </xsd:complexType>
+
+  <xsd:complexType name="addCredentialResponse">
+    <xsd:sequence>
+      <xsd:element name="result" type="xsd:string"/>
+      <xsd:element name="context" type="tns:contextInfo"/>
     </xsd:sequence>
   </xsd:complexType>
@@ -272,4 +306,18 @@
   </xsd:complexType>
 
+  <xsd:complexType name="flatGoalType">
+    <xsd:sequence>
+      <xsd:element name="Verifier"   type="xsd:string"/>
+      <xsd:choice>
+        <xsd:element name="TrustTarget" type="xsd:string"/>
+        <xsd:element name="LinkingTarget" type="xsd:string"/>
+      </xsd:choice>
+      <xsd:element name="Subject"   type="xsd:string"/>
+      <!-- The type string confirms whether this is a LinkingGoal or TT -->
+      <xsd:element name="Type"     type="xsd:string"/>
+    </xsd:sequence>
+  </xsd:complexType>
+
+
   <!-- Here are the new credential descriptions -->
 
